/******************************************************************
*:ļTBк
*
*******************************************************************/
#include "include.h"

uint16 TBCCR0_MOD = 0;

TB_ISR_CALLBACK TB_irq = (TB_ISR_CALLBACK)NULL;


/*
 * TB_PWM_Init
 * TBģPWMܳʼ
 * 
 * :
 *    freq--ƵʣλHz
 *
 * :
 *    
 */
void TB_PWM_Init(uint32 freq)
{
	uint32 mod = 0;
	uint8 ps = 0; //Ƶϵ
	CLKx clk;

	TB_TBCTL |= TB_TBCTL_TBCLR_MASK; //ʱB
	if((mod=_ACLK/(freq*8))<0xFFFF)
	 {
	  ps = 3;
	  TBCCR0_MOD = mod;
	  clk = ACLK;
	  if((mod=_ACLK/(freq*4))<0xFFFF)
	   {
	   	ps = 2;
		TBCCR0_MOD = mod;
		if((mod=_ACLK/(freq*2))<0xFFFF)
		 {
		  ps = 1;
		  TBCCR0_MOD = mod;
		  if((mod=_ACLK/(freq*1))<0xFFFF)
		   {
		    ps = 0;
		    TBCCR0_MOD = mod;
		   }
		 }
	   }
	 }
	if((mod=_SMCLK/(freq*8))<0xFFFF)
	 {
	  ps = 3;
	  TBCCR0_MOD = mod;
	  clk = SMCLK;
	  if((mod=_SMCLK/(freq*4))<0xFFFF)
	   {
	   	ps = 2;
		TBCCR0_MOD = mod;
		if((mod=_SMCLK/(freq*2))<0xFFFF)
		 {
		  ps = 1;
		  TBCCR0_MOD = mod;
		  if((mod=_SMCLK/(freq*1))<0xFFFF)
		   {
		    ps = 0;
		    TBCCR0_MOD = mod;
		   }
		 }
	   }
	 }
	TB_TBCTL = 0; //رնʱ
	TB_TBCTL = TB_TBCTL_TBCLGRP(0)+\
				TB_TBCTL_CNTLx(0)+\
				TB_TBCTL_TBSSELx(clk)+\
				TB_TBCTL_IDx(ps)+\
				TB_TBCTL_MCx(1);
		
	TB_TBCCR0 = TBCCR0_MOD;
}


/*
 * TB_PWM_Open
 * TBģPWMͨռձ
 * 
 * 
 * :
 *    channel - PWMͨ
 *      |__0--TB1
 *      |__1--TB2
 *      |__2--TB3
 *      |__3--TB4
 *      |__4--TB5
 *      |__5--TB6
 *    duty - PWMռձ
 *      |__0~10000--ռձ0.00%~100.00%
 *
 * :
 */
void TB_PWM_Open(uint8 channel, uint32 duty)
{
	switch(channel)
		{
			case 0:{
					TB_TBCCTL1 = TB_TBCCTLx_CLLDx(0)+\
									TB_TBCCTLx_CAP(0)+\
									TB_TBCCTLx_OUTMODx(6);
					TB_TBCCR1 = (uint16)((duty*TBCCR0_MOD)/10000);
				}
			break;
			case 1:{
					TB_TBCCTL2 = TB_TBCCTLx_CLLDx(0)+\
							    TB_TBCCTLx_CAP(0)+\
								TB_TBCCTLx_OUTMODx(6);
					TB_TBCCR2 = (uint16)((duty*TBCCR0_MOD)/10000);
				}
			break;
			case 2:{
					TB_TBCCTL3 = TB_TBCCTLx_CLLDx(0)+\
							    TB_TBCCTLx_CAP(0)+\
								TB_TBCCTLx_OUTMODx(6);
					TB_TBCCR3 = (uint16)((duty*TBCCR0_MOD)/10000);
				}
			break;
			case 3:{
					TB_TBCCTL4 = TB_TBCCTLx_CLLDx(0)+\
							    TB_TBCCTLx_CAP(0)+\
								TB_TBCCTLx_OUTMODx(6);
					TB_TBCCR4 = (uint16)((duty*TBCCR0_MOD)/10000);
				}
			break;
			case 4:{
					TB_TBCCTL5 = TB_TBCCTLx_CLLDx(0)+\
							    TB_TBCCTLx_CAP(0)+\
								TB_TBCCTLx_OUTMODx(6);
					TB_TBCCR5 = (uint16)((duty*TBCCR0_MOD)/10000);
				}
			break;
			case 5:{
					TB_TBCCTL6 = TB_TBCCTLx_CLLDx(0)+\
							    TB_TBCCTLx_CAP(0)+\
								TB_TBCCTLx_OUTMODx(6);
					TB_TBCCR6 = (uint16)((duty*TBCCR0_MOD)/10000);
				}
			break;
			
		}
}

/*
 * TB_PWM_ChangeDuty
 * ıFTM0ģPWMͨռձ
 *
 * :
 *    channel - PWMͨ
 *      |__0--TB1
 *      |__1--TB2
 *      |__2--TB3
 *      |__3--TB4
 *      |__4--TB5
 *      |__5--TB6
 *    duty - PWMռձ
 *      |__0~10000--ռձ0.00%~100.00%
 *
 * :
 */
void TB_PWM_ChangeDuty(uint8 channel, uint32 duty)
{
	switch(channel)
		{
			case 0:{
					TB_TBCCR1 = (uint16)((duty*TBCCR0_MOD)/10000);
				}
			break;
			case 1:{
					TB_TBCCR2 = (uint16)((duty*TBCCR0_MOD)/10000);
				}
			break;
			case 2:{
					TB_TBCCR3 = (uint16)((duty*TBCCR0_MOD)/10000);
				}
			break;
			case 3:{
					TB_TBCCR4 = (uint16)((duty*TBCCR0_MOD)/10000);
				}
			break;
			case 4:{
					TB_TBCCR5 = (uint16)((duty*TBCCR0_MOD)/10000);
				}
			break;
			case 5:{
					TB_TBCCR6 = (uint16)((duty*TBCCR0_MOD)/10000);
				}
			break;
		}
}


/*
 * TB_Timer_Init
 * TBڶʱۼʱĳʼ
 * 
 * :
 *    mode--ѡLPTMRģʽ
 *      |__MODE_Timer           --ʱģʽ
 *      |__MODE_PLACC           --ۼģʽ
 *    period_ms--趨ʱĶʱֵ λms
 *      |__0                    --ۼģʽʱѡΪ0
 *      |__1~65535              --1ms<= ʱ  <=7680ms 
 *    isr_func
 *      |__͹Ķʱжϻص
 *  
 * :
 */

void TB_Time_Init(uint8 mode, uint16 period_ms, TA_ISR_CALLBACK isr_func)
{
	uint32 mod;
	uint8 ps;
	uint16 _TBCCR0_MOD;
	CLKx clk;

	TB_TBCTL |= TB_TBCTL_TBCLR_MASK; //ʱB
	if(mode==MODE_Timer)  //ʱģʽ
		{
			if((mod=(period_ms*_ACLK)/(8*1000))<0xFFFF)
				{
					ps = 3;
					_TBCCR0_MOD = mod;
					clk = ACLK;
					if((mod=(period_ms*_ACLK)/(4*1000))<0xFFFF)
						{
							ps = 2;
							_TBCCR0_MOD = mod;
							if((mod=(period_ms*_ACLK)/(2*1000))<0xFFFF)
								{
									ps = 1;
									_TBCCR0_MOD = mod;
									if((mod=(period_ms*_ACLK)/(1*1000))<0xFFFF)
										{
											ps = 0;
											_TBCCR0_MOD = mod;
										}
								}
						}
				}
			if((mod=(period_ms*_SMCLK)/(8*1000))<0xFFFF)
				{
					ps = 3;
					_TBCCR0_MOD = mod;
					clk = SMCLK;
					if((mod=(period_ms*_SMCLK)/(4*1000))<0xFFFF)
						{
							ps = 2;
							_TBCCR0_MOD = mod;
							if((mod=(period_ms*_SMCLK)/(2*1000))<0xFFFF)
								{
									ps = 1;
									_TBCCR0_MOD = mod;
									if((mod=(period_ms*_SMCLK)/(1*1000))<0xFFFF)
										{
											ps = 0;
											_TBCCR0_MOD = mod;
										}
								}
						}
				}
			TB_TBCTL = 0; //رնʱ
			//ؼĴ
			TB_TBCTL = TB_TBCTL_TBCLGRP(0)+\
						TB_TBCTL_CNTLx(0)+\
						TB_TBCTL_TBSSELx(clk)+\
						TB_TBCTL_IDx(ps)+\
						TB_TBCTL_MCx(1);
			TB_TBCCTL0 = TB_TBCCTLx_CCIE(1)+\
							TB_TBCCTLx_CLLDx(0);
			TB_TBCCR0 = _TBCCR0_MOD;
			//жϺ
			TB_irq = isr_func;
		}
	else if(mode==MODE_PLACC)  //ģʽ
		{
			
			TB_TBCTL = TB_TBCTL_CNTLx(0)+\
						TB_TBCTL_TBSSELx(0)+\
						TB_TBCTL_IDx(0)+\
						TB_TBCTL_MCx(2);
			
		}
}

/*
 * TB_ClearIsr
 * TBûжϷж
 * 
 * :
 * :
 *	
 */
void TB_ClearIsr(void)
{
	uint16 BUF;
	BUF = TB_TBCTL;
	TB_irq = (TB_ISR_CALLBACK)NULL;
	TB_TBCTL &= ~TB_TBCTL_MCx_MASK;
	BUF &= ~TB_TBCTL_TBIE_MASK;
	TB_TBCTL &= ~TB_TBCTL_TBIE_MASK;
	TB_TBCTL =  BUF;
}


/*
 *  TB_DelayMs
 *  ͹Ķʱʱnms
 * 
 * :
 *    period_ms--趨ʱĶʱֵ λms
 *    65535ms
 *
 *  ֵ:
 *      
 */
void TB_DelayMs(uint16 period_ms)
{
	uint32 mod;
	uint8 ps;
	uint16 _TBCCR0_MOD;
	CLKx clk;
	TB_TBCTL |= TB_TBCTL_TBCLR_MASK; //ʱB
			if((mod=(period_ms*_ACLK)/(8*1000))<0xFFFF)
				{
					ps = 3;
					_TBCCR0_MOD = mod;
					clk = ACLK;
					if((mod=(period_ms*_ACLK)/(4*1000))<0xFFFF)
						{
							ps = 2;
							_TBCCR0_MOD = mod;
							if((mod=(period_ms*_ACLK)/(2*1000))<0xFFFF)
								{
									ps = 1;
									_TBCCR0_MOD = mod;
									if((mod=(period_ms*_ACLK)/(1*1000))<0xFFFF)
										{
											ps = 0;
											_TBCCR0_MOD = mod;
										}
								}
						}
				}
			if((mod=(period_ms*_SMCLK)/(8*1000))<0xFFFF)
				{
					ps = 3;
					_TBCCR0_MOD = mod;
					clk = SMCLK;
					if((mod=(period_ms*_SMCLK)/(4*1000))<0xFFFF)
						{
							ps = 2;
							_TBCCR0_MOD = mod;
							if((mod=(period_ms*_SMCLK)/(2*1000))<0xFFFF)
								{
									ps = 1;
									_TBCCR0_MOD = mod;
									if((mod=(period_ms*_SMCLK)/(1*1000))<0xFFFF)
										{
											ps = 0;
											_TBCCR0_MOD = mod;
										}
								}
						}
				}
			//ؼĴ
			TB_TBCTL = TB_TBCTL_TBCLGRP(0)+\
						TB_TBCTL_CNTLx(0)+\
						TB_TBCTL_TBSSELx(clk)+\
						TB_TBCTL_IDx(ps)+\
						TB_TBCTL_MCx(1);
			TB_TBCCR0 = _TBCCR0_MOD;
			
	//ȴʱ
	TB_TBCCTL0 &=0xFFFE;
	while((TB_TBCCTL0&0x0001)==0);
	TB_TBCCTL0 &=0xFFFE; //־λ
	TB_TBCTL = 0; //رնʱ
}

/*
 *  TB_GetPulseAcc
 *  õۼӵֵ
 * 
 *  :
 *      
 *  ֵ:
 *      ۼֵ
 */
uint16 TB_GetPulseAcc(void)
{
   return (uint16)TB_TBR;
}

/*
 * TB_Clear
 *  նʱTB  Counter
 * 
 *  :
 *      
 *  ֵ:
 *      
 */
void TB_Clear(void)
{
	TB_TBR = 0;
}
















/************************************************ж*******************************************************/

/*******************************************
ƣTA_Isr
    ܣTAⲿж
    
ֵ  
********************************************/
#pragma vector = TIMERB0_VECTOR
__interrupt void TB_Isr(void)
{
	TB_irq();
}








































