/******************************************************************
*:ļUARTк
*
*******************************************************************/
#include "include.h"

UART_ISR_CALLBACK uart_isr[2] = {(UART_ISR_CALLBACK)NULL};


/*
 * LPLD_UART_Init
 * ʼUARTͨ䲨
 * 
 * :
 *    uartx--UARTģ
 *      |__UART0          --UART0  -Txd:P3.4 -Rxd:P3.5
 *      |__UART1          --UART1  -Txd:P3.6  -Rxd:P3.7
 *    baud--ʣƼ³ò
 *      |__4800
 *      |__9600
 *      |__19200
 *      |__38400
 *      |__57600
 *      |__115200
 *
 * :
 *    
 *
 */
void UART_Init(UARTx uartx, uint32 baud)
{
	uint8 n = 0;
	switch(uartx)
		{
			case UART0:{
					USART0_U0CTL = UART_UxCTL_SWRST_MASK+\
									UART_UxCTL_CHAR(1);
					USART0_U0TCTL |= UART_UxTCTL_SSELx(3);
					//ʿ
					USART0_U0BR0 = (uint8)((uint32)(8000000/baud)%256);
					USART0_U0BR1 = (uint8)((uint32)(8000000/baud)/256);
					n = (uint8)(((8000000.0/baud)-(8000000/baud))*8);
					switch(n)
						{
							case 0:USART0_U0MCTL = 0x00;break;
							case 1:USART0_U0MCTL = 0x08;break;
							case 2:USART0_U0MCTL = 0x22;break;
							case 3:USART0_U0MCTL = 0x29;break;
							case 4:USART0_U0MCTL = 0xAA;break;
							case 5:USART0_U0MCTL = 0xAB;break;
							case 6:USART0_U0MCTL = 0xBB;break;
							case 7:USART0_U0MCTL = 0xF7;break;
							case 8:USART0_U0MCTL = 0xFF;break;
						}
					SFR_ME1 |= SFR_ME1_URXE0(1)+SFR_ME1_UTXE0(1);
					//SFR_ME2 |= SFR_ME2_URXE0(1)+SFR_ME2_UTXE0(1);
					USART0_U0CTL &= ~UART_UxCTL_SWRST_MASK;
				}
			break;
			case UART1:{
					USART1_U1CTL = UART_UxCTL_SWRST_MASK+\
									UART_UxCTL_CHAR(1);
					USART1_U1TCTL |= UART_UxTCTL_SSELx(3);
					//ʿ
					USART1_U1BR0 = (uint8)((uint32)(8000000/baud)%256);
					USART1_U1BR1 = (uint8)((uint32)(8000000/baud)/256);
					n = (uint8)(((8000000.0/baud)-(8000000/baud))*8);
					switch(n)
						{
							case 0:USART1_U1MCTL = 0x00;break;
							case 1:USART1_U1MCTL = 0x08;break;
							case 2:USART1_U1MCTL = 0x22;break;
							case 3:USART1_U1MCTL = 0x29;break;
							case 4:USART1_U1MCTL = 0xAA;break;
							case 5:USART1_U1MCTL = 0xAB;break;
							case 6:USART1_U1MCTL = 0xBB;break;
							case 7:USART1_U1MCTL = 0xF7;break;
							case 8:USART1_U1MCTL = 0xFF;break;
						}
					//SFR_ME1 |= SFR_ME1_URXE0(1)+SFR_ME1_UTXE0(1);
					SFR_ME2 |= SFR_ME2_URXE1(1)+SFR_ME2_UTXE1(1);
					USART1_U1CTL &= ~UART_UxCTL_SWRST_MASK;
				}
			break;
			
		}
}


/*
 * UART_GetChar
 * ڲѯʽȡһֽ
 * 
 * :
 *    uartx--UARTģ
 *      |__UART0          --UART0  -Txd:P3.4 -Rxd:P3.5
 *      |__UART1          --UART1  -Txd:P3.6  -Rxd:P3.7
 *
 * :
 *    ڽյ1ֽ
 *
 */
char UART_GetChar(UARTx uartx)
{
	char c = 0;
	switch(uartx)
		{
			case UART0:{
					while((SFR_IFG1&SFR_IFG1_URXIFG0_MASK)==0);
					c = USART0_U0RXBUF;
				}
			break;
			case UART1:{
					while((SFR_IFG2&SFR_IFG2_URXIFG1_MASK)==0);
					c = USART1_U1RXBUF;
				}
			break;
		}
	return c;
}

/*
 * UART_GetCharINT
 * жϷʽȡһֽ
 * 
 * :
 *    uartx--UARTģ
 *      |__UART0          --UART0  -Txd:P3.4 -Rxd:P3.5
 *      |__UART1          --UART1  -Txd:P3.6  -Rxd:P3.7
 *
 * :
 *    ڽյ1ֽ
 *
 */
char UART_GetCharINT(UARTx uartx)
{
	char c = 0;
	switch(uartx)
		{
			case UART0:{
					c = USART0_U0RXBUF;
				}
			break;
			case UART1:{	
					c = USART1_U1RXBUF;
				}
			break;
		}
	return c;
}


/*
 * UART_PutChar
 * ڲѯʽһֽ
 * 
 * :
 *    uartx--UARTģ
 *      |__UART0          --UART0  -Txd:P3.4 -Rxd:P3.5
 *      |__UART1          --UART1  -Txd:P3.6  -Rxd:P3.7
 *    ch--͵1ֽ
 *
 * :
 *    
 *
 */
void UART_PutChar(UARTx uartx, char ch)
{
	switch(uartx)
		{
			case UART0:{
					while((USART0_U0TCTL&UART_UxTCTL_TXEPT_MASK)==0);
					USART0_U0TXBUF = ch;
				}
			break;
			case UART1:{
					while((USART1_U1TCTL&UART_UxTCTL_TXEPT_MASK)==0);
					USART1_U1TXBUF = ch;
				}
			break;
		}
}

/*
 * UART_PutCharArr
 * ڲѯʽֽ
 * 
 * :
 *    uartx--UARTģ
 *      |__UART0          --UART0  -Txd:P3.4 -Rxd:P3.5
 *      |__UART1          --UART1  -Txd:P3.6  -Rxd:P3.7
 *    *ch--͵ֽͷַ
 *    len--ֽ鳤
 *
 * :
 *    
 *
 */
void UART_PutCharArr(UARTx uartx, char *ch, int len)
{
	for(;len>0;len--)
		{
			UART_PutChar(uartx,*(ch++));
		}
}


/*
 * UART_RIE_Enable
 * ʹܴݽжϣжϺ
 * 
 * :
 *    uartx--UARTģ
 *      |__UART0          --UART0  -Txd:P3.4 -Rxd:P3.5
 *      |__UART1          --UART1  -Txd:P3.6  -Rxd:P3.7
 *    isr_func--ݽжϳڵַ
 *      |__ûڹļ¶жϺΪ:޷ֵ,޲(eg. void isr(void);)
 *
 * :
 *    
 *
 */
void UART_RIE_Enable(UARTx uartx, UART_ISR_CALLBACK isr_func)
{
	switch(uartx)
		{
			case UART0:{
					SFR_IE1 |= SFR_IE1_URXIE0_MASK;
					uart_isr[0] = isr_func;
				}
			break;
			case UART1:{
					SFR_IE2 |= SFR_IE2_URXIE1_MASK;
					uart_isr[1] = isr_func;
				}
			break;
		}
}


/*
 * UART_RIE_Disable
 * ôݽж
 * 
 * :
 *    uartx--UARTģ
 *      |__UART0          --UART0  -Txd:P3.4 -Rxd:P3.5
 *      |__UART1          --UART1  -Txd:P3.6  -Rxd:P3.7
 *
 * :
 *    
 *
 */
void UART_RIE_Disable(UARTx uartx)
{
	
	switch(uartx)
		{
			case UART0:{
					SFR_IE1 &= ~SFR_IE1_URXIE0_MASK;
				}
			break;
			case UART1:{
					SFR_IE2 &= ~SFR_IE2_URXIE1_MASK;
				}
			break;
		}
}











/************************************************ж*******************************************************/

/*******************************************
ƣUART0R_Isr
    ܣUART0ж
    
ֵ  
********************************************/
#pragma vector = USART0RX_VECTOR
__interrupt void UART0R_Isr(void)
{
	uart_isr[0]();
}

/*******************************************
ƣUART1R_Isr
    ܣUART1ж
    
ֵ  
********************************************/
#pragma vector = USART1RX_VECTOR
__interrupt void UART1R_Isr(void)
{
	uart_isr[1]();
}



