/******************************************************************
*:ļж˲ͼк
*
*******************************************************************/
#include "include.h"
#include "draw.h"
#include "nokia5110.h"
#include "math.h"

/*
 * Ren_LCD
 * ˢĻ
 * 
 * : 
 *    screen--Ļ
 * :
 *    
 */
void Ren_LCD(SCREEN screen)
{
	uint8 x=0,y=0;
	for(y=0;y<6;y++)
		{
			x = 0;
			NOKIA_set_XY(x,y);
			for(x=0;x<84;x++)
				{
					NOKIA_write_byte(screen[y][x], 1);
				}
		}
}




/*
 * Cls_Rec
 * 
 * 
 * : 
 * Ͻ
 *    x1--
 *    y1-- 
 * ½
 *    x2--
 *    y2-- 
 *    screen--Ļ
 * :
 *    
 */
void Cls_Rec(uint8 x1,uint8 y1,uint8 x2,uint8 y2,SCREEN screen)
{
	uint8 a1,b1,a2,b2;
	uint8 i,x;
	a1 = y1/8;
	b1 = y1%8;
	a2 = y2/8;
	b2 = y2%8;
	for(i=0;i<6;i++)
		{
			for(x = x1;x<=x2;x++)
				{
					if((a1==i)&&(a2==i))
						{
							screen[i][x] &= (~(0xff<<b1)|(0xff<<b2));
						}
					if((a1==i)&&(a2>i))
						{
							screen[i][x] &= (~(0xff<<b1));
						}
					if((a1<i)&&(a2>i))
						{
							screen[i][x] &= 0x00;
						}
					if((a1<i)&&(a2==i))
						{
							screen[i][x] &= ((0xff<<b2));
						}
				}
		}
}


/*
 * Fill_Rec
 * 
 * 
 * : 
 * Ͻ
 *    x1--
 *    y1-- 
 * ½
 *    x2--
 *    y2-- 
 *    screen--Ļ
 * :
 *    
 */
void Fill_Rec(uint8 x1,uint8 y1,uint8 x2,uint8 y2,SCREEN screen)
{
	uint8 a1,b1,a2,b2;
	uint8 i,x;
	a1 = y1/8;
	b1 = y1%8;
	a2 = y2/8;
	b2 = y2%8;
	for(i=0;i<6;i++)
		{
			for(x = x1;x<=x2;x++)
				{
					if((a1==i)&&(a2==i))
						{
							screen[i][x] |= ((0xff<<b1)&~(0xff<<b2));
						}
					if((a1==i)&&(a2>i))
						{
							screen[i][x] |= ((0xff<<b1));
						}
					if((a1<i)&&(a2>i))
						{
							screen[i][x] |= 0xFF;
						}
					if((a1<i)&&(a2==i))
						{
							screen[i][x] |= (~(0xff<<b2));
						}
				}
		}
}



/*
 * Invented_Clear
 * Ļ
 * 
 * : 
 *    screen--Ļ
 * :
 *    
 */

void Invented_Clear(SCREEN screen)
{
	Cls_Rec(0,0,83,47,screen);
}






/*
 * Painting
 * Ļϴ
 * 
 * :
 *    x--
 *    y--      
 *    screen--Ļ
 *   colour--ɫ
 *      |__0--ɫ
 *      |__1--ɫ
 * :
 *    
 */
void Painting(uint8 x,uint8 y,uint8 colour,SCREEN screen)
{
	uint8 y1,y2;
	y1 = y/8;
	y2 = y%8;
	//
	if(colour)
		{
			screen[y1][x] |= 0x01<<y2;
		}
	else
		{
			screen[y1][x] &= ~(0x01<<y2);
		}
	
}

/*
 * Line
 * ߺ
 * 
 * :
 *    :
 *    x1--
 *    y1--      
 *    յ:
 *    x2--
 *    y2--      
 *    screen--Ļ
 *   colour--ɫ
 *      |__0--ɫ
 *      |__1--ɫ
 * :
 *    
 */
void Line(uint8 x1,uint8 y1,uint8 x2,uint8 y2,uint8 colour,SCREEN screen)
{
	uint8 x,y;
	for(x=x1;x<=x2;x++)
		{
			y = (uint8)(((float)(y2-y1)/(x2-x1))*(x-x1)+y1);
			Painting(x,y,colour,screen);
		}
}

/*
 * Circle1
 * Բ
 * 
 * :
 *    Բĵ:
 *    x--
 *    y--      
 *    뾶:
 *    r--뾶      
 *    screen--Ļ
 *   colour--ɫ
 *      |__0--ɫ
 *      |__1--ɫ
 * :
 *    
 */
void Circle1(uint8 x1,uint8 y1,uint8 r,uint8 colour,SCREEN screen)
{
	int x = 0,y = r;
	int d = 10 - r;
	while(y > x)                     // y>xһ޵ĵ˷Բ
		{

			Painting(x+x1,y+y1,colour,screen);         // Բ(x1,y1),ʱֱƽ,
			Painting(y+x1,x+y1,colour,screen);         // 
			Painting(-x+x1,y+y1,colour,screen);        // 
			Painting(-y+x1,x+y1,colour,screen);        // 
			Painting(-x+x1,-y+y1,colour,screen);       // 
			Painting(-y+x1,-x+y1,colour,screen);       // 
			Painting(x+x1,-y+y1,colour,screen);        // 
			Painting(y+x1,-x+y1,colour,screen);        // 
			if(d < 0)

				d = d + 2 * x + 3;                        // dı仯
			else

			{

				d = d + 2 * (x - y) + 4;                  // d <= 0ʱ,dı仯
				y--;                                      // y
			}

			x++;                                           // x
		}

	
}

/*
 * Circle2
 * Բ
 * 
 * :
 *    Բĵ:
 *    x--
 *    y--      
 *    뾶:
 *    r--뾶      
 *    screen--Ļ
 *   colour--ɫ
 *      |__0--ɫ
 *      |__1--ɫ
 * :
 *    
 */
void Circle2(uint8 x1,uint8 y1,uint8 r,uint8 colour,SCREEN screen)
{
	long x,y;
	for(x=0;x<=r;x++)
		{
			y=(long)(sqrt(r*r-(x)*(x)));
			Painting((x+x1),(y+y1),colour,screen);
			Painting((-x+x1),(y+y1),colour,screen);
			Painting((-x+x1),(-y+y1),colour,screen);
			Painting((x+x1),(-y+y1),colour,screen);
		}
}

/*
 * Circle
 * Բ
 * 
 * :
 *    Բĵ:
 *    x--
 *    y--      
 *    뾶:
 *    r--뾶      
 *    screen--Ļ
 *   colour--ɫ
 *      |__0--ɫ
 *      |__1--ɫ
 * :
 *    
 */
void Circle(uint8 x1,uint8 y1,uint8 r,uint8 colour,SCREEN screen)
{
	long x,y;
	float ra;
	for(ra=0;ra<=1.57;ra+=(2*3.14)/60)
		{
			x=(long)(r*cos(ra));
			y=(long)(r*sin(ra));
			Painting((x+x1),(y+y1),colour,screen);
			Painting((-x+x1),(y+y1),colour,screen);
			Painting((-x+x1),(-y+y1),colour,screen);
			Painting((x+x1),(-y+y1),colour,screen);
		}
}





